--- func_cut.c	2008-12-11 22:46:29.000000000 +0100
+++ func_cut.c	2009-05-27 20:02:24.000000000 +0200
@@ -205,15 +205,21 @@
 					tmp2 = NULL;
 
 				/* Output fields until we either run out of fields or num2 is reached */
+				int firstfield = 0;
 				while (tmp2 != NULL && curfieldnum <= num2) {
 					char *tmp3 = strsep(&tmp2, ds);
 					int curlen = strlen(buffer);
 
-					if (curlen)
+					if (curlen) {
 						snprintf(buffer + curlen, buflen - curlen, "%c%s", d, tmp3);
-					else
-						snprintf(buffer, buflen, "%s", tmp3);
-
+					} else {
+						if (!firstfield) {
+							snprintf(buffer, buflen, "%s", tmp3);
+							firstfield = 1;
+						} else {
+							snprintf(buffer, buflen, "%c%s", d, tmp3);
+						}
+					}
 					curfieldnum++;
 				}
 			}
